<template>
  <div class="app-container">
    <!-- 搜索 -->
    <el-form inline size="mini">
      <el-form-item label="资源平台：">
        <el-select v-model="form.platformId" placeholder="请选择资源平台" clearable>
          <el-option v-for="item in platformOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="音频类型：">
        <el-select v-model="form.audioType" placeholder="请选择音频类型" clearable>
          <el-option v-for="item in form.platformId === '' ? audioOptions : audioTypeOptions" :key="item.value"
            :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item label="内容标题：">
        <el-input v-model="form.audioName" placeholder="请输入内容标题" clearable />
      </el-form-item>
      <el-form-item label="当前状态：">
        <el-select v-model="form.status" placeholder="请选择当前状态" clearable>
          <el-option v-for="item in disabledOptions" :key="item.value" :value="item.value" :label="item.label" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="getSearch">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="getRefresh">重置</el-button>
        <el-button type="primary" plain icon="el-icon-plus" @click="getDetail()"
          v-hasPermi="['registration:content:add']">新增</el-button>
      </el-form-item>
    </el-form>
    <!-- 列表 -->
    <el-table :data="tableData" v-loading="loading">
      <el-table-column label="序号" type="index" align="center" />
      <el-table-column label="内容标题" prop="audioName" align="center" />
      <el-table-column label="内容图片" align="center" width="100px">
        <template slot-scope="scope">
          <el-image :src="scope.row.pic" />
        </template>
      </el-table-column>
      <el-table-column label="资源平台" prop="platformId" align="center" :formatter="platformFormatter" />
      <el-table-column label="音频类型" prop="audioType" align="center" :formatter="audioTypeFormatter" />
      <el-table-column label="当前状态" prop="status" align="center" :formatter="statusFormatter" />
      <el-table-column label="内容状态" prop="currentStatus" align="center" :formatter="currentFormatter" />
      <el-table-column label="有效时间" align="center" show-overflow-tooltip>
        <template slot-scope="scope">
          {{ scope.row.startTime }} 至 {{ scope.row.endTime }}
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center">
        <template slot-scope="scope">
          <el-button type="text" @click="getDetail(scope.row.id, true)">查看</el-button>
          <span v-if="scope.row.status === 1">
            <el-button type="text" @click="getDetail(scope.row.id)" v-hasPermi="['registration:content:edit']"
              style="margin-left: 10px">编辑</el-button>
            <el-button type="text" @click="getChange(scope.row, 0)" v-hasPermi="['registration:content:up']">
              上架</el-button>
            <el-button type="delete" @click="getDelete(scope.row)"
              v-hasPermi="['registration:content:delete']">删除</el-button>
          </span>
          <el-button v-else type="delete" @click="getChange(scope.row, 1)"
            v-hasPermi="['registration:content:down']">下架</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="form.pageNum" :limit.sync="form.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>
import { platformMixin, audioMixin, disabledMixin, currentMixin } from '@/mixin/index'
import { list, change, remove } from '@/api/registration/content'
export default {
  mixins: [platformMixin, audioMixin, disabledMixin, currentMixin],
  data() {
    return {
      // 遮罩层
      loading: false,
      // 表单
      form: {
        pageNum: 1,
        pageSize: 10,
        audioType: '',
        platformId: ''
      },
      // 列表
      tableData: [],
      // 总数据
      total: 0
    }
  },
  watch: {
    'form.platformId': {
      handler(val) {
        if (val && this.form.audioType == '') {
          this.form.audioType = ''
          this.getAudioType(val)
          this.getList()
        }
      },
      deep: true
    },
    'form.audioType': {
      handler(val) {
        if (val && this.form.platformId == '') {
          this.form.platformId = ''
          this.getPlatform({
            audioType: val
          })
          this.getList()
        }
      },
      deep: true
    }
  },
  mounted() {
    this.getList()
    this.getPlatform({})
  },
  methods: {
    // 列表
    getList() {
      this.loading = true
      list(this.form).then(res => {
        if (res.code === 0) {
          this.tableData = res.data.records
          this.total = res.data.total
          this.loading = false
        }
      })
    },

    // 搜索
    getSearch() {
      this.form.pageNum = 1
      this.getList()
    },

    // 重置
    getRefresh() {
      this.form = {
        pageNum: 1,
        pageSize: 10,
        platformId: '',
        audioType: ''
      }
      this.getList()
    },

    // 新增 查看 编辑
    getDetail(id, boolean) {
      this.$router.push({
        path: `/registration/contentConfig/detail`,
        query: {
          id: id,
          disabled: boolean
        }
      })
    },

    // 上下架
    getChange(row, status) {
      let title = status === 0 ? '上架' : '下架'
      this.$confirm(`是否${title}${row.audioName}?`, '提示', {
        type: 'warning'
      }).then(() => {
        change({
          id: row.id,
          status: status
        }).then(res => {
          if (res.code === 0) {
            this.$message.success(`${title}成功！`)
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 删除
    getDelete(row) {
      this.$confirm(`是否删除${row.audioName}?`, '提示', {
        type: 'warning'
      }).then(() => {
        remove({
          id: row.id
        }).then(res => {
          if (res.code === 0) {
            this.$message.success('删除成功！')
            this.getList()
          }
        })
      }).catch(() => { })
    },

    // 字典翻译
    platformFormatter(row) {
      return this.selectDictLabel(this.platformOptions, row.platformId)
    },
    audioTypeFormatter(row) {
      return this.selectDictLabel(this.audioOptions, row.audioType)
    },
    statusFormatter(row) {
      return this.selectDictLabel(this.disabledOptions, row.status)
    },
    currentFormatter(row) {
      return this.selectDictLabel(this.currentOptions, row.currentStatus)
    }
  }
}
</script>